/*
Copyright Kumori.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by lister-gen. DO NOT EDIT.

package v1

import (
	v1 "gitlab.com/mandanga-public/sub1/sub2/client-go/pkg/apis/kumori/v1"
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
)

// KukuCNLister helps list KukuCNs.
type KukuCNLister interface {
	// List lists all KukuCNs in the indexer.
	List(selector labels.Selector) (ret []*v1.KukuCN, err error)
	// KukuCNs returns an object that can list and get KukuCNs.
	KukuCNs(namespace string) KukuCNNamespaceLister
	KukuCNListerExpansion
}

// kukuCNLister implements the KukuCNLister interface.
type kukuCNLister struct {
	indexer cache.Indexer
}

// NewKukuCNLister returns a new KukuCNLister.
func NewKukuCNLister(indexer cache.Indexer) KukuCNLister {
	return &kukuCNLister{indexer: indexer}
}

// List lists all KukuCNs in the indexer.
func (s *kukuCNLister) List(selector labels.Selector) (ret []*v1.KukuCN, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v1.KukuCN))
	})
	return ret, err
}

// KukuCNs returns an object that can list and get KukuCNs.
func (s *kukuCNLister) KukuCNs(namespace string) KukuCNNamespaceLister {
	return kukuCNNamespaceLister{indexer: s.indexer, namespace: namespace}
}

// KukuCNNamespaceLister helps list and get KukuCNs.
type KukuCNNamespaceLister interface {
	// List lists all KukuCNs in the indexer for a given namespace.
	List(selector labels.Selector) (ret []*v1.KukuCN, err error)
	// Get retrieves the KukuCN from the indexer for a given namespace and name.
	Get(name string) (*v1.KukuCN, error)
	KukuCNNamespaceListerExpansion
}

// kukuCNNamespaceLister implements the KukuCNNamespaceLister
// interface.
type kukuCNNamespaceLister struct {
	indexer   cache.Indexer
	namespace string
}

// List lists all KukuCNs in the indexer for a given namespace.
func (s kukuCNNamespaceLister) List(selector labels.Selector) (ret []*v1.KukuCN, err error) {
	err = cache.ListAllByNamespace(s.indexer, s.namespace, selector, func(m interface{}) {
		ret = append(ret, m.(*v1.KukuCN))
	})
	return ret, err
}

// Get retrieves the KukuCN from the indexer for a given namespace and name.
func (s kukuCNNamespaceLister) Get(name string) (*v1.KukuCN, error) {
	obj, exists, err := s.indexer.GetByKey(s.namespace + "/" + name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v1.Resource("kukucn"), name)
	}
	return obj.(*v1.KukuCN), nil
}
